/*
 * 
 * sxhexout.c - This file containes the routine that will actually write the hex codes to a file on disk
 * 
 * Kris Bahnsen  <kbahnsen@gmail.com>
 * Copyright (C) 2007 Kris Bahnsen
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
 */


#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "sxhexout.h"

extern char	*hex_file_out;

int	writelines(unsigned short int opcodes[256][16], unsigned short int id[16], unsigned short int fuse[2], int sx182028)
{
	
	//int temp;
	int x, linenum, totlines;
	short int line;
	unsigned short int  bytehold1,bytehold2, chksum;//, sx28fusetemp[2];

	if(sx182028) totlines = 127;
	else if(!sx182028) totlines = 255;
   
	FILE * hexfile;
	for(x = (strlen(hex_file_out) - 1);hex_file_out[x] != 0x00 && (int)hex_file_out[x] != '.';x--);
	strncpy(hex_file_out+((strlen(hex_file_out)) - ((strlen(hex_file_out)) - 1 - x)),"hex", 3);  //this is so we can have [sourcefile].hex

	hexfile = fopen(hex_file_out,"w");
	if(hexfile != NULL)
	{
		line = 0x00;
		for(linenum = 0; linenum <= totlines; linenum++)
		{
	
			chksum = 0;
			fprintf(hexfile, ":20%03X000",(linenum * 2));	//write the rest of the lines
			for(x = 0;x <= 15;x++)  //this does byteswapping
			{
				bytehold1 = bytehold2 = (int)opcodes[linenum][x];
				bytehold1 <<= 8;
				bytehold2 >>= 8;
				chksum = ((bytehold1 >> 8) + bytehold2 + chksum);
				//printf("%X ",chksum);
				fprintf(hexfile,"%04X",(bytehold1+bytehold2));
			}	
		
			chksum = ~chksum;
			chksum <<= 8;
			chksum >>= 8;
			chksum++;
			chksum = (chksum - (0x20 + line));		
			chksum <<= 8;
			chksum >>= 8;
			if(line >= 0x100) (chksum = chksum - 0x10);
			if(line == 0x100)
			{
				chksum <<= 8;
				chksum >>= 8;
			}
			fprintf(hexfile,"%02X\x0D\x0A",chksum);
			//printf("line = %X, listed number = %03X, chk = %04X\n",line,linenum * 2,chksum);
			switch(line)
			{
				case 0xE0:
					line = 0x01;
					break;
				case 0xE1:
					line = 0x02;
					break;
				case 0xE2:
					line = 0x03;
					break;
				case 0xE3:
					line = 0x04;
					break;
				case 0xE4:
					line = 0x05;
					break;
				case 0xE5:
					line = 0x06;
					break;
				case 0xE6:
					line = 0x07;
					break;
				case 0xE7:
					line = 0x08;
					break;
				case 0xE8:
					line = 0x09;
					break;
				case 0xE9:
					line = 0x0A;
					break;
				case 0xEA:
					line = 0x0B;
					break;
				case 0xEB:
					line = 0x0C;
					break;
				case 0xEC:
					line = 0x0D;
					break;
				case 0xED:
					line = 0x0E;
					break;
				case 0xEE:
					line = 0x0F;
					break;
				case 0xEF:
					line = 0x100;
					break;	
				case 0x1E0:
					line = 0x101;
					break;
				case 0x1E1:
					line = 0x102;
					break;
				case 0x1E2:
					line = 0x103;
					break;
				case 0x1E3:
					line = 0x104;
					break;
				case 0x1E4:
					line = 0x105;
					break;
				case 0x1E5:
					line = 0x106;
					break;
				case 0x1E6:
					line = 0x107;
					break;
				case 0x1E7:
					line = 0x108;
					break;
				case 0x1E8:
					line = 0x109;
					break;
				case 0x1E9:
					line = 0x10A;
					break;
				case 0x1EA:
					line = 0x10B;
					break;
				case 0x1EB:
					line = 0x10C;
					break;
				case 0x1EC:
					line = 0x10D;
					break;
				case 0x1ED:
					line = 0x10E;
					break;
				case 0x1EE:
					line = 0x10F;	
					break;	
				default:
					line += 0x20;
					break;
			}
		}
		
		//Put ID line here

			fprintf(hexfile, ":20200000");
			for(x = 0;x <= 15;x++)
			{
				bytehold1 = bytehold2 = id[x];
				bytehold1 <<= 8;
				bytehold2 >>= 8;
				fprintf(hexfile,"%04X",(bytehold1+bytehold2));
			}
			fprintf(hexfile,"E0\x0D\x0A");  //temporary fake checksum
			

			fprintf(hexfile, ":04202000");	//FUSE line
			chksum = 0;
			//insert calculations
			for(x = 0;x <= 1;x++)
			{
				bytehold1 = bytehold2 = fuse[x]; 
				bytehold1 <<= 8;
				bytehold2 >>= 8;
				chksum = ((bytehold1 >> 8) + bytehold2 + chksum);
				fprintf(hexfile,"%04X",(bytehold1+bytehold2));
			}
			chksum = ~chksum;
			chksum <<= 8;
			chksum >>= 8;
			chksum++;
			chksum = (chksum - 0x44);
			chksum <<= 8;
			chksum >>= 8;
			fprintf(hexfile,"%02X\x0D\x0A",chksum);
			fprintf(hexfile, ":00000001FF\x0D\x0A"); //Add final line
			
		
		fclose(hexfile);
	}
	else
	{
		fprintf(stderr, "Error opening file\n");
		exit(1);
	}
	return 0;
}
